/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables.records;


import be.lghs.accounting.model.tables.MovementCategories;

import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MovementCategoriesRecord extends UpdatableRecordImpl<MovementCategoriesRecord> implements Record4<UUID, String, String, String> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>accounting.movement_categories.id</code>.
     */
    public void setId(UUID value) {
        set(0, value);
    }

    /**
     * Getter for <code>accounting.movement_categories.id</code>.
     */
    public UUID getId() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>accounting.movement_categories.name</code>.
     */
    public void setName(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>accounting.movement_categories.name</code>.
     */
    public String getName() {
        return (String) get(1);
    }

    /**
     * Setter for <code>accounting.movement_categories.description</code>.
     */
    public void setDescription(String value) {
        set(2, value);
    }

    /**
     * Getter for <code>accounting.movement_categories.description</code>.
     */
    public String getDescription() {
        return (String) get(2);
    }

    /**
     * Setter for <code>accounting.movement_categories.type</code>.
     */
    public void setType(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>accounting.movement_categories.type</code>.
     */
    public String getType() {
        return (String) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row4<UUID, String, String, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    @Override
    public Row4<UUID, String, String, String> valuesRow() {
        return (Row4) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return MovementCategories.MOVEMENT_CATEGORIES.ID;
    }

    @Override
    public Field<String> field2() {
        return MovementCategories.MOVEMENT_CATEGORIES.NAME;
    }

    @Override
    public Field<String> field3() {
        return MovementCategories.MOVEMENT_CATEGORIES.DESCRIPTION;
    }

    @Override
    public Field<String> field4() {
        return MovementCategories.MOVEMENT_CATEGORIES.TYPE;
    }

    @Override
    public UUID component1() {
        return getId();
    }

    @Override
    public String component2() {
        return getName();
    }

    @Override
    public String component3() {
        return getDescription();
    }

    @Override
    public String component4() {
        return getType();
    }

    @Override
    public UUID value1() {
        return getId();
    }

    @Override
    public String value2() {
        return getName();
    }

    @Override
    public String value3() {
        return getDescription();
    }

    @Override
    public String value4() {
        return getType();
    }

    @Override
    public MovementCategoriesRecord value1(UUID value) {
        setId(value);
        return this;
    }

    @Override
    public MovementCategoriesRecord value2(String value) {
        setName(value);
        return this;
    }

    @Override
    public MovementCategoriesRecord value3(String value) {
        setDescription(value);
        return this;
    }

    @Override
    public MovementCategoriesRecord value4(String value) {
        setType(value);
        return this;
    }

    @Override
    public MovementCategoriesRecord values(UUID value1, String value2, String value3, String value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached MovementCategoriesRecord
     */
    public MovementCategoriesRecord() {
        super(MovementCategories.MOVEMENT_CATEGORIES);
    }

    /**
     * Create a detached, initialised MovementCategoriesRecord
     */
    public MovementCategoriesRecord(UUID id, String name, String description, String type) {
        super(MovementCategories.MOVEMENT_CATEGORIES);

        setId(id);
        setName(name);
        setDescription(description);
        setType(type);
    }
}
